#include "free-tree.h"

MallocTable * table;

void InitializeMallocTable() {
    table = malloc(sizeof(MallocTable));
    table->elements = malloc(DEFAULT_TABLE_SIZE * sizeof(void *));
    table->size = DEFAULT_TABLE_SIZE;
    table->used = 0;
}

void AddMalloc(void * pointer) {
    if (table->used == table->size) {
        table->elements = realloc(table->elements, 2 * table->size);
        table->size *= 2;
    }
    table->elements[table->used++] = pointer;
}

void FreeMallocTable() {
    for (int i = 0; i < table->used; i++) {
        free(table->elements[i]);
    }
    free(table->elements);
    free(table);
}
